#include "arm.h"
#include "asm_passes.h"

void remove_redundant_moves(Program_Asm *prog) {
    int cnt = 0;
    for(auto f : prog->functions) {
        for(auto mb : f->mbs) {
            MI *next_instr = mb->inst;
            for(auto I = mb->inst; I; I=next_instr) {
                next_instr = I->next;
                if(I->tag == MI_MOVE) {
                    auto mv = (MI_Move *)I;
                    if(mv->src.tag == IMM || mv->dst.tag == REG)
                        continue;
                    if(auto use = mv->src.get_use_head(f); use && use->next == nullptr) {
                        {
                            auto defs = get_defs(I);
                            auto uses = get_uses(I, f->has_return_value);
                            // for(auto def: defs) {
                            //     print_operand(def);
                            //     printf(",");
                            // }
                            // for(auto use: uses) {
                            //     print_operand(use);
                            //     printf(",");
                            // }
                            // printf(" MI_Tag: %d\n", I->tag);
                        }
                        replace_operand_by_operand(&mv->dst, &mv->src, f);
                        mv->erase_from_parent();
                        cnt ++;
                    }
                }
            }
        }
    }
    printf("[opt]: remove_redundant_moves ereased %d instructions\n", cnt);
}
