#include "arm.h"
#include "asm_passes.h"

static bool maybe_unused(MI_Tag kind) {
    // return !(kind == MI_FUNC_CALL || kind == MI_PUSH || kind == MI_POP 
    //       || kind == MI_VPUSH || kind == MI_VPOP || kind == MI_STORE
    //       || kind == MI_VSTORE || kind == MI_BRANCH);
    
    return kind == MI_BINARY || kind == MI_LOAD || kind == MI_MOVE;
}

static bool s_maybe_unused(MI_Tag kind) {
    // return !(kind == MI_FUNC_CALL || kind == MI_PUSH || kind == MI_POP 
    //       || kind == MI_VPUSH || kind == MI_VPOP || kind == MI_STORE
    //       || kind == MI_VSTORE || kind == MI_BRANCH);
    
    return kind == MI_VBINARY || kind == MI_VLOAD || kind == MI_VMOVE;
}

void remove_unused_instruction(Program_Asm *prog) {
    int cnt = 0;
    printf("begin remove_unused_instruction:\n");
    for(auto f : prog->functions) {
        for(auto mb : f->mbs) {
            MI *next_instr = mb->inst;
            for(auto I = mb->inst; I; I=next_instr) {
                next_instr = I->next;
                if(maybe_unused(I->tag)) {
                    auto defs = get_defs(I);
                    bool unused = defs.size() > 0;
                    for(auto def: defs) {
                        if(def.get_use_head(f) != nullptr || def.tag == REG) {
                            unused = false;
                            break;
                        }
                    }
                    // printf(" -> ");
                    // {
                    //     auto defs = get_defs(I);
                    //     auto uses = get_uses(I, f->has_return_value);
                    //     for(auto def: defs) {
                    //         print_operand(def);
                    //         printf(",");
                    //     }
                    //     for(auto use: uses) {
                    //         print_operand(use);
                    //         printf(",");
                    //     }
                    //     printf(" MI_Tag: %d\n", I->tag);
                    // }

                    if(unused) {
                        // printf("erase instruction: ");
                        // auto defs = get_defs(I);
                        // auto uses = get_uses(I, f->has_return_value);
                        // for(auto def: defs) {
                        //     print_operand(def);
                        //     printf(",");
                        // }
                        // for(auto use: uses) {
                        //     print_operand(use);
                        //     printf(",");
                        // }
                        // printf(" MI_Tag: %d\n", I->tag);
                        I->erase_from_parent();
                        cnt ++;
                    }
                }
                else if(s_maybe_unused(I->tag)) {
                    auto defs = s_get_defs(I);
                    bool unused = defs.size() > 0;
                    for(auto def: defs) {
                        if(def.s_get_use_head(f) != nullptr || def.tag == SREG) {
                            unused = false;
                            break;
                        }
                    }

                    if(unused) {
                        // printf("erase instruction: ");
                        // auto defs = s_get_defs(I);
                        // auto uses = s_get_uses(I, f->has_return_value);
                        // for(auto def: defs) {
                        //     print_operand(def);
                        //     printf(",");
                        // }
                        // for(auto use: uses) {
                        //     print_operand(use);
                        //     printf(",");
                        // }
                        // printf(" MI_Tag: %d\n", I->tag);
                        I->erase_from_parent();
                        cnt ++;
                    }
                }
            }
        }
    }
    printf("[opt]: remove unused instruction ereased %d instructions\n", cnt);
}
