#pragma once

#include <memory>
#include <unordered_map>
#include <unordered_set>
#include "Block.h"
#include "StringTable.h"

struct Block;
struct BasicBlock;
struct Instruction;
struct Function
{
    ValuePtr retVal;
    shared_ptr<BasicBlock> returnBasicBlock;
    string name;
    vector<ValuePtr> formArguments;
    shared_ptr<Block> block;
    bool isLib;
    bool isReenterable;

    //记录该函数的调用者以及调用次数
    unordered_map<shared_ptr<Function>,int> caller;
    //记录该函数调用的函数以及调用次数
    unordered_map<shared_ptr<Function>,int> callee;

    std::unordered_set<shared_ptr<Instruction>> callerIns;

    void setReturnBasicBlock();
    // 定义
    Function(TypePtr returnType, string name, vector<ValuePtr> formArguments, shared_ptr<Block> block);
    Function(TypePtr returnType, string name, bool isReenterable, vector<ValuePtr> formArguments=vector<ValuePtr>()) : retVal{ValuePtr(new Reg(returnType, "retval"))}, name{name}, formArguments{formArguments}, block{nullptr}, isLib{true} , isReenterable{isReenterable} {};
    void solveReturnBasicBlock();

    string getTypeStr() { return retVal->type->getStr() + " @" + name; }
    void print();
};
typedef shared_ptr<Function> FunctionPtr;