#include "HHDCE.h"

unordered_set<BasicBlockPtr> bbs;

void HHDCE(Module &ir) {

    cout<< "Enter HHDCE" << endl;
    for(auto func: ir.globalFunctions)
    {
        if(func->isLib)
            continue;
        if(func->name=="main")
        {
            // if(!func->retVal->isConst)
            // {
                
            //     cout << "not const ret" << endl;
            //     return;
            // }

            for(auto bb:func->block->basicBlocks)
            {
                for(auto instr:bb->instructions)
                {
                    if(instr->type == Return)
                    {
                        auto ret = dynamic_cast<ReturnInstruction*> (instr.get());
                        if(!ret->retValue->isConst)
                        {
                            cout << ret->retValue->getStr() << endl;
                            cout<< "Not const ret" << endl;
                            return ;
                        }
                    }
                }
            }

            for(auto bb: func->block->basicBlocks) {
                for(auto instr: bb->instructions)
                {
                    if(instr->type ==Call)
                    {
                        auto call = dynamic_cast<CallInstruction*>(instr.get());
                        if(call->func->isLib)
                        {
                            for(auto val:call->argv)
                            {
                                if(!val->isConst)
                                {
                                    cout <<"val is not const" << endl;
                                    return ;
                                }
                            }
                            bbs.insert(bb);
                        }
                    }
                }
            }
        }
    }

    if(bbs.size()!=2)
    {
        cout << "not 2 blocks" << endl;
        return;
    }

    BasicBlockPtr entrybb = nullptr;
    BasicBlockPtr endbb = nullptr;
    for(auto bb: bbs)
    {
        cout << "bb is " << bb->label->name << endl;
        if(bb->label->name == "entry")
        {
            entrybb = bb;
        }
        else
        {
            endbb = bb;
        }
    }
    if(!entrybb || !endbb)
    {
        cout << "No entry or end " << endl;
        return;
    }
    for(auto instr:entrybb->instructions)
    {
        if(instr->type == Br)
        {
            auto brins = dynamic_cast<BrInstruction*> (instr.get());
            if(brins->label2!=nullptr)
            {
                cout << "entry complicated" << endl;
                return;
            }
            brins->label1 = endbb->label;
            brins->label2 = nullptr;
            brins->exp = nullptr;
            break;
        }
    }
    entrybb->succBasicBlocks.clear();
    entrybb->succBasicBlocks.insert(endbb);
    endbb->predBasicBlocks.clear();
    endbb->predBasicBlocks.insert(entrybb);
    cout << "Done !!!" << endl;

    return;
}
