#include "LoopRorate.h"

bool processLoop(Loop *L)
{
    bool SimplifiedLatch = false;

    SimplifiedLatch = simplifyLoopLatch(L);

    bool MadeChange = rotateLoop(L, SimplifiedLatch);
    assert(!MadeChange || L->getExitBlocks().count(L->getLatchBlock()));

    return MadeChange || SimplifiedLatch;
}
bool rotateLoop(Loop *L, bool SimplifiedLatch)
{
    return false;
}
bool simplifyLoopLatch(Loop *L)
{

    BasicBlockPtr Latch = L->getLatchBlock();
    if (!Latch)
    {
        cerr << "No Latch" << endl;
        return false;
    }

    BrInstruction *Jmp = dynamic_cast<BrInstruction *>(Latch->endInstruction.get());
    /*if (!Jmp || !Jmp->isUnconditional())
    {
        return false;
    }*/

    BasicBlockPtr LastExit = Latch->getPredecessor().size() == 1 ? Latch->directDominator : nullptr;
    if (!LastExit || !L->getExitingBlocks().count(LastExit))
    {
        return false;
    }

    BrInstruction *BI = dynamic_cast<BrInstruction *>(LastExit->endInstruction.get());
    if (!BI)
    {
        return false;
    }

    // 将Latch的Jmp之前的指令，移动到LastExit的BI之前
    while(auto LatchInstr = Latch->instructions.front())
    {
        if (LatchInstr == Latch->instructions.back()) break;
        LastExit->insertInstruction(LatchInstr, LastExit->endInstruction);
        Latch->removeInsturction(LatchInstr);
    }

    return false;
    // unsigned FallThruPath = BI->
}

void LoopRorate(BlockPtr block)
{
    int moveCount = 0;
    vector<LoopPtr> Loops = block->loops;
    int numLoops = Loops.size();
    // cerr << "numLoops " << numLoops << "\n";
    for (int i = 0; i < numLoops; i++)
    {
        processLoop(Loops[i].get());
    }
}