#include "loadStoreEliminate.h"

bool isSameGEP(InstructionPtr a,InstructionPtr b){
    assert(a->type==GEP&&b->type==GEP&&"input should be GEP");
    auto G1 = dynamic_cast<GetElementPtrInstruction*>(a.get());
    auto G2 = dynamic_cast<GetElementPtrInstruction*>(b.get());
    if(G1->from!=G2->from){
        return false;
    }
    if(G1->index.size()!=G2->index.size()){
        return false;
    }
    for(int i=0;i<G1->index.size();i++){
        if(G1->index[i]!=G2->index[i]){
            return false;
        }
    }
    return true;
}

void arrayConstProInBB(BasicBlockPtr BB){
    for(auto Ins:BB->instructions){
        // Ins->print();
        if(Ins->type == Load){
            auto LI = dynamic_cast<LoadInstruction*>(Ins.get());
            if(LI->from->I&&LI->from->I->type == GEP){
                for(auto preIns:BB->instructions){
                    if(preIns==Ins){
                        break;
                    }
                    else if(preIns->type==Store){
                        // cout<<"pre  ";
                        // preIns->print();
                        // fflush(stdout);
                        
                        auto SI = dynamic_cast<StoreInstruction*>(preIns.get());
                   
                        if(SI->des->I&&SI->des->I->type == GEP){
                            if(isSameGEP(LI->from->I->getSharedThis(), SI->des->I->getSharedThis())){
                                // cerr<<"before\n";
                                printf("from: ");
                                SI->print();
                                printf("to: ");
                                Ins->print();
                                fflush(stdout);
                                replaceVarByVar(Ins->reg, SI->value);
                                deleteUser(Ins->reg);
                                // cerr<<"end \n";
                            }
                        }
                    }
                }
            }
        }
        else if(Ins->type == Call)
            return;
    }
}


void loadStoreEliminate(FunctionPtr func){
    for(auto BB:func->block->basicBlocks){
        // cerr<<BB->label->name<<endl;
        arrayConstProInBB(BB);
    }
}