#include "loopReconstruct.h"
#include "LICM.h"

// int copy_num =0;

// void unuseall(InstructionPtr ins)
// {
//     auto operands_num = ins->getNumOperands();
//     for(int i=0;i<operands_num;i++)
//     {
//         auto operand = ins->getOperand(i);
//         if(operand)
//         {
//             deleteUser(operand);
//         }
//     }
// }



void runReOnLoop(LoopPtr loop, BlockPtr block)
{
    int maxTripCount = 80;

    auto legalLoop = [&](LoopPtr loop) -> bool {
        // 1. Loop can not have break. At our simplify loop continue become 
        // to the common for loop
        if(loop->getExitingBlocks().size() != 1 || loop->getExitBlocks().size() != 1 || loop->getSubLoops().size())
        {
            // cerr << "exiting size is " << loop->getExitingBlocks().size() << " " <<  loop->getExitBlocks().size() <<endl;
            // error("111\n");
            return false;    
        } 
                                   // It must to be 1 at any time.
        auto trip = loop->getTripCount();
        if( trip!=0)
        {
            // std::cerr << "333" <<std::endl;
            return false;
        }
            
        // 3. Do not have any function call.
        for(auto bb : loop->getBasicBlocks())
            for(auto instr : bb->instructions)
                if(instr->type == Call)
                    return false;
        
        for(auto bb : loop->getBasicBlocks())
            for(auto instr : bb->instructions)
                if(instr->type == Icmp && bb != loop->header)
                    return false;
        
        auto phi = loop->indPhi;

        if(!loop->hasSCEV(phi))
        {
            return false;
        }
        auto& scev = loop->getSCEV(phi);
        auto endval = loop->indEnd;
        auto initval = scev.at(0);
        auto stepval = scev.at(1);
        if(endval && initval && initval ->isConst && stepval && stepval->isConst)
        {

            auto cInitial = dynamic_cast<Const *>(initval.get());
            auto cStep = dynamic_cast<Const *>(stepval.get());
            if(cInitial->intVal == 0 && cStep->intVal == 1)
            {
                return true;
            }
        }

        // for (auto instr : loop->getLatchBlock()->instructions)
        //     if (instr->type != Binary)
        //     {
        //         if (instr->type != Br)
        //             return false;
        //     }

        return false;
    };


    if(!legalLoop(loop))
    {
        // cout << "Not Legal" <<endl;
        return;
    }
    else
    {
        // cout << "Legal" << endl;
    }

    // error("unpass init of header\n");
    // cerr << "unpass init of header" << endl;
        
    
    auto header = loop->getHeader();

    // error("[passed] 1 init of header\n");
    auto latch = loop->latchBlock;
    // error("[passed] 2 init of header\n");

    // std::cerr << "header is " << header->label->getStr() << endl;
    // std::cerr << "latch is " << latch->label->getStr() << endl;
    auto exit = *loop->getExitBlocks().begin();

    if(exit->instructions[0]->type!=Binary)
    {
        return;
    }

    auto reminstr = exit->instructions[0];

    auto rembi = dynamic_cast<BinaryInstruction*> (exit->instructions[0].get());
    if(rembi->op!='%')
    {
        return;
    }

    InstructionPtr target = nullptr;

    for(auto instr: latch->instructions)
    {
        if(instr->type != Binary)
            continue;
        auto bi = dynamic_cast<BinaryInstruction*> (instr.get());
        if(bi->a == rembi->a || bi->b == rembi->b)
        {
            target = instr;
            // cout << "Find the instr!!!!" << endl;
            fflush(stdout);
            break;
        }
    }

    if(target == nullptr)
        return;

    auto idxval = loop->indEnd;
    auto tarbi = dynamic_cast<BinaryInstruction*> (target.get());
    ValuePtr ans = nullptr;
    InstructionPtr newins =nullptr;
    if(tarbi->op == '+' && !tarbi -> a ->isConst && tarbi -> b -> isConst)
    {
        // cout << "Begin to remove" << endl;
        fflush(stdout);


        newins = InstructionPtr (new BinaryInstruction(idxval,tarbi->b,'*',BasicBlockPtr(nullptr)));
        ans = newins ->reg;
        auto newbi = dynamic_cast<BinaryInstruction*> (newins.get());
        newbi->isrv64 = true;
        rembi->isrv64 =true;
        InstructionPtr pos = nullptr;

        exit->insertInstruction(newins,reminstr);
        replaceVarByVar(rembi->a, ans);
        deleteUser(rembi->a);

        // cout << "Replace Var by var" << endl;
        fflush(stdout);

         for(auto instr: loop->preHeader->instructions)
        {
            if(instr->type ==Br)
            {
                auto brins = dynamic_cast<BrInstruction*>(instr.get());
                assert(brins->label2 == nullptr);
                if(brins->label2 == nullptr)
                    brins->label1 = exit->label;
            }
        }

        exit->predBasicBlocks.clear();
        exit->predBasicBlocks.insert(loop->preHeader);
        // cout<< "Done !!!" << endl;

    }

    else if(tarbi->op == '+' && tarbi -> a ->isConst && !tarbi -> b -> isConst)
    {
        // cout << "Begin to remove" << endl;
        fflush(stdout);


        newins = InstructionPtr (new BinaryInstruction(idxval,tarbi->a,'*',BasicBlockPtr(nullptr)));
        ans = newins ->reg;
        auto newbi = dynamic_cast<BinaryInstruction*> (newins.get());
        newbi->isrv64 = true;
        rembi->isrv64 =true;
        InstructionPtr pos = nullptr;

        exit->insertInstruction(newins,reminstr);
        replaceVarByVar(rembi->a, ans);
        deleteUser(rembi->a);

        // cout << "Replace Var by var" << endl;
        fflush(stdout);

         for(auto instr: loop->preHeader->instructions)
        {
            if(instr->type ==Br)
            {
                auto brins = dynamic_cast<BrInstruction*>(instr.get());
                assert(brins->label2 == nullptr);
                if(brins->label2 == nullptr)
                    brins->label1 = exit->label;
            }
        }

        exit->predBasicBlocks.clear();
        exit->predBasicBlocks.insert(loop->preHeader);
        // cout<< "Done !!!" << endl;

    }
    


   
}

// @FIXME: bug when compiling 09_BFS and almost useless
void loopReconstruct(BlockPtr block) {
    cout << "Enter loop rere" << endl;
    queue<LoopPtr> QueWorkList;
    for(auto loop : block->getAllLoops())
    {
        if(loop->getParentLoop()!=nullptr)
            continue;
        else
            QueWorkList.push(loop);
    }
    while(!QueWorkList.empty())
    {
        auto loop = QueWorkList.front();
        QueWorkList.pop();
        runReOnLoop(loop, block);
        for(auto subLoop : loop->getSubLoops())
            QueWorkList.push(subLoop);
    }
    
}